//+------------------------------------------------------------------+
//|                                      Elliott Wave Oscillator.mq4 |
//|                                                tonyc2a@yahoo.com |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "tonyc2a@yahoo.com"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red

//
//
//
//
//

extern string TimeFrame      = "Current time frame";
extern int    Fast.MA.Period = 5;
extern int    Slow.MA.Period = 34;
extern int    Signal.period  = 5;
extern int    arrowSize      = 2; 

//
double      Buffer1[],
            Buffer2[],
            CrossUp[],
            CrossDn[],
            trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,CrossUp);  SetIndexStyle(0,DRAW_ARROW,0,arrowSize); SetIndexArrow(0,233);
   SetIndexBuffer(1,CrossDn ); SetIndexStyle(1,DRAW_ARROW,0,arrowSize); SetIndexArrow(1,234);
   SetIndexBuffer(2,Buffer1);
   SetIndexBuffer(3,Buffer2);
   SetIndexBuffer(4,trend);
   
      //
      //
      //
      //
      //

       indicatorFileName = WindowExpertName();
       calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
       returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
       timeFrame         = stringToTimeFrame(TimeFrame);
         
      //
      //
      //
      //
      //
         
   IndicatorShortName(timeFrameToString(timeFrame)+  " Elliot Wave Oscillator ");
return(0);
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
//
//

int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { CrossUp[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {   
     for (i=limit; i>=0; i--) Buffer1[i] = iMA(NULL,0,Fast.MA.Period,0,MODE_SMA,PRICE_MEDIAN,i)-
                                        iMA(NULL,0,Slow.MA.Period,0,MODE_SMA,PRICE_MEDIAN,i);
     for (i=limit; i>=0; i--) 
     {
        Buffer2[i] = iMAOnArray(Buffer1,0,Signal.period,0,MODE_LWMA,i);
        trend[i] = trend[i+1];
           if(Buffer1[i] > Buffer2[i]) trend[i] = 1;
           if(Buffer1[i] < Buffer2[i]) trend[i] =-1;
         
           //
           //
           //
           //
           //
      
           CrossUp[i] = EMPTY_VALUE;
           CrossDn[i] = EMPTY_VALUE;
           if (trend[i]!= trend[i+1])
           if (trend[i] == 1)
                 CrossUp[i+1] =  Low[i+1] - 10*Point;
           else  CrossDn[i+1] = High[i+1] + 10*Point;
     }
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Fast.MA.Period,Slow.MA.Period,Signal.period,4,y);
         Buffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Fast.MA.Period,Slow.MA.Period,Signal.period,2,y);
         Buffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Fast.MA.Period,Slow.MA.Period,Signal.period,3,y);
         CrossUp[i] = EMPTY_VALUE;
         CrossDn[i] = EMPTY_VALUE;
         if (trend[i]!= trend[i+1])
         if (trend[i] == 1)
               CrossUp[i+1] =  Low[i+1] - 10*Point;
         else  CrossDn[i+1] = High[i+1] + 10*Point;
      }
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}



